王者之剑题解

2051. 王者之剑

时间限制:1 s   内存限制:256 MB

【题目描述】

这是在阿尔托利亚·潘德拉贡成为英灵前的事情,她正要去拔出石中剑成为亚瑟王,在这之前她要去收集一些宝石。

宝石排列在一个n*m的网格中,每个网格中有一块价值为v(i,j)的宝石,阿尔托利亚·潘德拉贡可以选择自己的起点。

开始时刻为0秒。以下操作,每秒按顺序执行

1.在第i秒开始的时候,阿尔托利亚·潘德拉贡在方格(x,y)上,她可以拿走(x,y)中的宝石。

2.在偶数秒,阿尔托利亚·潘德拉贡周围四格的宝石会消失

3.若阿尔托利亚·潘德拉贡第i秒开始时在方格(x,y)上,则在第i+1秒可以立即移动到(x+1,y),(x,y+1),(x-1,y)或(x,y-1)上,也可以停留在(x,y)上。

求阿尔托利亚·潘德拉贡最多可以获得多少价值的宝石

【输入格式】

第一行给出数字N,M代表行列数.N,M均小于等于100,宝石的价值不会超过10000.下面N行M列用于描述数字矩阵

【输出格式】

输出最多可以拿到多少价值宝石

【样例输入】

2 2

1 2

2 1

【样例输出】

4solution:    这个题其实很简单,我们不用去管如何走,只要取得格子相容一定会有合法路径。     有不相容的便想到了最小割,割掉最小不相容的点,获得最大利益。     先将棋盘黑白染色,将白色的点和S连接,边权为容量;再将黑色的点和T连接,边权也是容量。     这时再将所有白色的点和周围不相容的点连接,边权为inf。S对于白点就是取,从路径来说,S-白—黑—T,因为中间部分容量为inf,所以只能割掉两边的边,割掉的就是舍弃的格子。
  1 #include<cstdio>
  2 #include<cstring>
  3 #include<iostream>
  4 using namespace std;
  5 #define min(a,b) ((a)<(b)?(a):(b))
  6 #define inf 1e9
  7 int read() {
  8     int s=0,f=1;
  9     char ch=getchar();
 10     while(ch>‘9‘||ch<‘0‘) {
 11         if(ch==‘-‘) {
 12             f=-1;
 13         }
 14         ch=getchar();
 15     }
 16     while(ch>=‘0‘&&ch<=‘9‘) {
 17         s=(s<<1)+(s<<3)+(ch^48);
 18         ch=getchar();
 19     }
 20     return s*f;
 21 }
 22 int n,m,zong,num[105][105],S,T,val[10005],tot,r[10005],sum;
 23 bool col[10005];
 24 struct oo {
 25     int to,next,vv;
 26 } c[200005];
 27 void add(int x,int y,int z) {
 28     c[tot].to=y;
 29     c[tot].vv=z;
 30     c[tot].next=r[x];
 31     r[x]=tot++;
 32 }
 33 void readandprint() {
 34     memset(r,-1,sizeof(r));
 35     n=read();
 36     m=read();
 37     int state=1;
 38     S=0,T=n*m+1;
 39     for(int i=1; i<=n; i++) {
 40         for(int j=1; j<=m; j++) {
 41             num[i][j]=++zong;
 42             val[num[i][j]]=read();
 43             sum+=val[num[i][j]];
 44         }
 45     }
 46     T=zong+1;
 47     for(int j=1; j<=m; j++) {
 48         col[num[1][j]]=state;
 49         state^=1;
 50     }
 51     for(int i=2; i<=n; i++) {
 52         for(int j=1; j<=m; j++) {
 53             col[num[i][j]]=col[num[i-1][j]]^1;
 54         }
 55     }
 56     for(int i=1;i<=n;i++){
 57         for(int j=1;j<=m;j++){
 58             if(!col[num[i][j]]) { //bai
 59                 add(S,num[i][j],val[num[i][j]]);
 60                 add(num[i][j],S,0);
 61             }
 62             if(col[num[i][j]]) { //hei
 63                 add(num[i][j],T,val[num[i][j]]);
 64                 add(T,num[i][j],0);
 65             }
 66         }
 67     }
 68
 69     for(int i=1; i<=n; i++) {
 70         for(int j=1; j<=m; j++) {
 71             if(!col[num[i][j]]){
 72                 if(i<n) {
 73                     add(num[i][j],num[i+1][j],inf);
 74                     add(num[i+1][j],num[i][j],0);
 75                 }
 76                 if(j<m) {
 77                     add(num[i][j],num[i][j+1],inf);
 78                     add(num[i][j+1],num[i][j],0);
 79                 }
 80                 if(i>1) {
 81                     add(num[i][j],num[i-1][j],inf);
 82                     add(num[i-1][j],num[i][j],0);
 83                 }
 84                 if(j>1) {
 85                     add(num[i][j],num[i][j-1],inf);
 86                     add(num[i][j-1],num[i][j],0);
 87                 }
 88             }
 89         }
 90     }
 91 }
 92 int queue[100005],head,tail,deep[10005];
 93 bool bfs(int s,int t) {
 94     memset(deep,0,sizeof(deep));
 95     head=tail=0;
 96     deep[s]=1;
 97     queue[++tail]=s;
 98     while(head<tail) {
 99         int opt=queue[++head];
100         for(int i=r[opt]; ~i; i=c[i].next) {
101             if(c[i].vv&&!deep[c[i].to]) {
102                 deep[c[i].to]=deep[opt]+1;
103                 queue[++tail]=c[i].to;
104                 if(c[i].to==t) {
105                     return 1;
106                 }
107             }
108         }
109     }
110     return 0;
111 }
112 int dfs(int opt,int fw) {
113     if(opt==T) {
114         return fw;
115     }
116     int tmp=fw,k;
117     for(int i=r[opt]; ~i; i=c[i].next) {
118         if(tmp&&c[i].vv&&deep[c[i].to]==deep[opt]+1) {
119             k=dfs(c[i].to,min(c[i].vv,tmp));
120             if(!k) {
121                 deep[c[i].to]=0;
122                 continue;
123             }
124             c[i].vv-=k;
125             c[i^1].vv+=k;
126             tmp-=k;
127         }
128     }
129     return fw-tmp;
130 }
131 int dinic(int s,int t) {
132     int ans=0;
133     while(bfs(s,t)) {
134         ans+=dfs(s,inf);
135     }
136     return ans;
137 }
138 int Main(){
139     freopen("Excalibur.in","r",stdin);
140     freopen("Excalibur.out","w",stdout);
141     readandprint();
142     int ans=dinic(S,T);
143     printf("%d\n",sum-ans);
144     return 0;
145 }
146 int hehe=Main();
147 int main() {
148     ;
149 }
时间: 2024-12-17 03:12:45

王者之剑题解的相关文章

洛谷 P1079 Vigen&#232;re 密码 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:https://www.luogu.org/problem/show?pid=1079 题目描述 16 世纪法国外交家 Blaise de Vigenère 设计了一种多表密码加密算法――Vigenère 密 码.Vigenère 密码的加密解密算法简单易用,且破译难度比较高,曾在美国南北战争中为 南军所广泛使用. 在密码学中,我们称需要加密的信息为明文,用 M 表示:称加密后的信息为密文,用 C 表示:而密钥是一种

8.8联考题解

今天的T1让我怀疑我是不是在做奥赛题--这考的是什么知识点啊这个,会不会用绝对值函数? Evensgn 的债务 时间限制: 1 Sec  内存限制: 128 MB 题目描述 Evensgn 有一群好朋友,他们经常互相借钱.假如说有三个好朋友A,B,C.A 欠 B 20 元,B 欠 C 20 元,总债务规模为 20+20=40 元.Evensgn 是个追求简约的人,他觉得这样的债务太繁杂了.他认为,上面的债务可以完全等价为 A 欠C20 元,B 既不欠别人,别人也不欠他.这样总债务规模就压缩到了 

POJ 2533 - Longest Ordered Subsequence(最长上升子序列) 题解

此文为博主原创题解,转载时请通知博主,并把原文链接放在正文醒目位置. 题目链接:http://poj.org/problem?id=2533 Description A numeric sequence of ai is ordered if a1 < a2 < ... < aN. Let the subsequence of the given numeric sequence (a1, a2, ..., aN) be any sequence (ai1, ai2, ..., aiK)

(leetcode题解)Pascal&#39;s Triangle

Pascal's Triangle  Given numRows, generate the first numRows of Pascal's triangle. For example, given numRows = 5,Return [ [1], [1,1], [1,2,1], [1,3,3,1], [1,4,6,4,1] ] 题意实现一个杨辉三角. 这道题只要注意了边界条件应该很好实现出来,C++实现如下 vector<vector<int>> generate(int

2017ZZUACM省赛选拔试题部分题解----谨以纪念我这卡线滚粗的美好经历

写在前面: 其实心里有些小小的不爽又有点小小的舒畅,为啥捏?不爽当然是因为没被选拔上啦,舒畅捏则是因为没被选拔上反而让自己警醒,学长也提点很多很多."沉下去,然后一战成名"学长如是对我说,我很开心.其实这完全算不算是题解,只是我个人的一些小想法而已.而且到现在还有一题不会...让自己长点记性吧. 题目 A :聪明的田鼠 Time Limit: 1 Sec Memory Limit: 128 MB Description 田鼠MIUMIU来到了一片农田,农田可以看成是一个M*N个方格的矩

LeetCode-001题解

此题目摘自LeetCode001 Given an array of integers, find two numbers such that they add up to a specific target number. The function twoSum should return indices of the two numbers such that they add up to the target, where index1 must be less than index2.

leetcode题解: Next Permutation

最近还一直在刷leetcode,当然,更多时候只是将题解写在自己的电脑上,没有分享出来.偶尔想起来的时候,就写出来. public class Solution { public void nextPermutation(int[] nums) { if(nums==null||nums.length<=1) return; nextPermutationHelp( nums,0,nums.length-1); } public void nextPermutationHelp(int []nu

HDU 5014 Number Sequence(2014 ACM/ICPC Asia Regional Xi&#39;an Online) 题解

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5014 Number Sequence Problem Description There is a special number sequence which has n+1 integers. For each number in sequence, we have two rules: ● ai ∈ [0,n] ● ai ≠ aj( i ≠ j ) For sequence a and sequ

HDU 1045 Fire Net 二分图Bipartite题解

本题可以使用DFS直接爆搜出答案,不过这样类型的题目其实是个二分图的题解. 这个二分图,难不在Hungary算法,而是难在于建图.需要挺高的抽象思维的. 建图: 1 把同一行不被X分开的格子标同一个号码,被X分开的标下一个号码,这样做是为了缩点,不需要把所有的格子都分开标号,而且可以更方便建个更加小的图. 2 同理把同一列的格子标号 3 然后判断相同一个格子的行标号和列标号是有路径的,其他不在同一个格子的都是没有路径的. 4 这样就等于以行标号和列标号作为左右顶点,构建成一个二分图了 然后使用H